part of dungeon;

class Character extends Sprite {
  static Character mage;
  static Character warrior;
  static Sprite wallMarkedToRemove;

  Vector2 direction = Vector2.ZERO;
  int health;
  int energy;
  double velocity = 32.0;
  double walkMeter = 0.0;
  bool active;

  Character(Texture texture, Vector2 position):
    super(texture, position, Block.SIZE) {
    if (texture.name == "warrior") {
      health = 5;
      energy = 3;
      active = true;
      warrior = this;
    } else {
      health = 3;
      energy = 5;
      active = false;
      mage = this;
    }
  }

  void update() {
    if (active) {
      if (direction == Vector2.ZERO) {
        Vector2 d = Vector2.ZERO;

        if (Keyboard.isLeftPressed) {
          d += Vector2.LEFT;
        }

        if (Keyboard.isRightPressed) {
          d += Vector2.RIGHT;
        }

        if (Keyboard.isUpPressed) {
          d += Vector2.UP;
        }

        if (Keyboard.isDownPressed) {
          d += Vector2.DOWN;
        }

        if (d.x != 0 && d.y != 0) {
          d = Vector2.ZERO;
        }

        if (d == Vector2.UP) {
          up();
        } else if (d == Vector2.DOWN) {
          down();
        } else if (d == Vector2.LEFT) {
          left();
        } else if (d == Vector2.RIGHT) {
          right();
        }
      }

        if (walkMeter >= velocity) {
          direction = Vector2.ZERO;
          position = new Vector2(location.x * velocity, location.y * 32.0);
          walkMeter = 0.0;
        }

        position += direction * velocity * Time.delta * 3.0;
      }

      if (direction != Vector2.ZERO) {
        walkMeter += Time.delta * velocity * 3.0;
      }
  }

  bool cannotWalk(Sprite sprite) {
    if (sprite.texture.isButton) {
      String name = sprite.texture.name.replaceFirst("button", "wall");

      wallMarkedToRemove =
          game.components.firstWhere((e) => e.texture.name == name, orElse: () => null);
    }

    return //sprite is Sprite &&
      !sprite.texture.isFloor &&
      !sprite.texture.isButton;
  }

  void up() {
    if (location.y == 0) {
      return;
    }

    for (Component component in game.components) {
      if (location.x == component.location.x) {
        if (location.y == component.location.y + 1) {
          if (cannotWalk(component)) {
            return;
          }
        }
      }
    }

    if (direction == Vector2.ZERO) {
      direction = Vector2.UP;
      location += Point2.UP;
      walkMeter = 0.0;
    }
  }

  void down() {
    if (location.y == 7) {
      return;
    }

    for (Component component in game.components) {
      if (location.x == component.location.x) {
        if (location.y == component.location.y - 1) {
          if (cannotWalk(component)) {
            return;
          }
        }
      }
    }

    if (direction == Vector2.ZERO) {
      direction = Vector2.DOWN;
      location += Point2.DOWN;
      walkMeter = 0.0;
    }
  }

  void left() {
    if (location.x == 0) {
      return;
    }

    for (Component component in game.components) {
      if (location.y == component.location.y) {
        if (location.x == component.location.x + 1) {
          if (cannotWalk(component)) {
            return;
          }
        }
      }
    }

    if (direction == Vector2.ZERO) {
      direction = Vector2.LEFT;
      location += Point2.LEFT;
      walkMeter = 0.0;
    }
  }

  void right() {
    if (location.x == 14) {
      return;
    }

    for (Component component in game.components) {
      if (location.y == component.location.y) {
        if (location.x == component.location.x - 1) {
          if (cannotWalk(component)) {
            return;
          }
        }
      }
    }

    if (direction == Vector2.ZERO) {
      direction = Vector2.RIGHT;
      location += Point2.RIGHT;
      walkMeter = 0.0;
    }
  }
}