part of dungeon;

class Game extends Scene with Component {
  static int WIDTH = 960;
  static int HEIGHT = 540;
  static double SCALE = 2.0;

  CanvasElement canvas;
  static CanvasRenderingContext2D canvasContext;

  Map map;

  Game() {
    canvas = new CanvasElement(width: WIDTH, height: HEIGHT);
    document.body.children.add(canvas);
    canvasContext = canvas.context2D;

    map = new Map(Assets.map0);
    components = map.components;

    window.onKeyDown.listen((e) {
      switch (e.keyCode) {
        case 17:
          Keyboard.isControlPressed = true;

          if (Character.mage.walkMeter == 0.0 &&
              Character.warrior.walkMeter == 0.0) {
            Character.mage.active = !Character.mage.active;
            Character.warrior.active = !Character.warrior.active;
          }

          break;
        case 32:
          Keyboard.isSpacePressed = true;
          break;
        case 37:
          Keyboard.isLeftPressed = true;
          break;
        case 38:
          Keyboard.isUpPressed = true;
          break;
        case 39:
          Keyboard.isRightPressed = true;
          break;
        case 40:
          Keyboard.isDownPressed = true;
          break;
      }
    });

    window.onKeyUp.listen((e) {
      switch (e.keyCode) {
        case 17:
          Keyboard.isControlPressed = false;
          break;
        case 32:
          Keyboard.isSpacePressed = false;
          break;
        case 37:
          Keyboard.isLeftPressed = false;
          break;
        case 38:
          Keyboard.isUpPressed = false;
          break;
        case 39:
          Keyboard.isRightPressed = false;
          break;
        case 40:
          Keyboard.isDownPressed = false;
          break;
      }
    });
  }

  void run() => loop(0);

  void loop(num milliseconds) {
    num d = milliseconds - Time.ellapsedMilliseconds;
    Time.delta = d / 1000;
    Time.ellapsedMilliseconds = milliseconds;

    update();
    draw();

    window.requestAnimationFrame(loop);
  }

  void update() {
    for (Component component in components) {
      component.update();
    }

    if (Character.wallMarkedToRemove != null) {
      game.components.remove(Character.wallMarkedToRemove);
      Character.wallMarkedToRemove = null;
    }

  }

  void draw() {
    context.clearRect(0, 0, WIDTH, HEIGHT);

    for (Component component in components) {
      component.draw();
    }
  }
}