part of dungeon;

class Map {
  List<Component> components = [];
  int x;
  int y;

  void addComponent(Texture texture) {
    Component component = new Sprite(
        texture,
        new Vector2(
            x * Block.SIZE.x,
            y * Block.SIZE.y),
            Block.SIZE);

    component.location = new Point2(x, y);
    components.add(component);
  }

  void addNPC(Texture texture, Vector2 direction) {
    NPC npc = new NPC(
        texture,
        new Vector2(
            x * Block.SIZE.x,
            y * Block.SIZE.y),
            Block.SIZE, direction);

    npc.location = new Point2(x, y);
    components.add(npc);
  }

  void addCharacter(Texture texture) {
    Character character = new Character(
        texture,
        new Vector2(
            x * Block.SIZE.x,
            y * Block.SIZE.y));

    character.location = new Point2(x, y);
    components.add(character);
  }

  Map(String map) {
//    HttpRequest.getString("assets/maps/$name.txt")
//      .then((map) {
        y = 0;

        for (String line in map.split("\n")) {
          x = 0;

          for (int c in line.codeUnits) {
            switch (new String.fromCharCode(c)) {
              case "#":
                if (x < 7) {
                  addComponent(Assets.redWall);
                } else if (x == 7) {
                  addComponent(Assets.grayWall);
                } else {
                  addComponent(Assets.blueWall);
                }

                break;
              default:
                if (x >= 6 && x <= 8 && y >= 2 && y <= 4) {
                  addComponent(Assets.grayFloor);
                } else if (x < 7) {
                  addComponent(Assets.redFloor);
                } else {
                  addComponent(Assets.blueFloor);
                }

                break;
            }

            x++;
          }

          y++;
        }

        y = 0;

        for (String line in map.split("\n")) {
          x = 0;

          for (int c in line.codeUnits) {
            switch (new String.fromCharCode(c)) {
//              case "<":
//                if (x < 7) {
//                  addNPC(Assets.redNPC, Vector2.LEFT);
//                } else {
//                  addNPC(Assets.blueNPC, Vector2.LEFT);
//                }
//
//                break;
//              case "^":
//                if (x < 7) {
//                  addNPC(Assets.redNPC, Vector2.UP);
//                } else {
//                  addNPC(Assets.blueNPC, Vector2.UP);
//                }
//
//                break;
//              case ">":
//                if (x < 7) {
//                  addNPC(Assets.redNPC, Vector2.RIGHT);
//                } else {
//                  addNPC(Assets.blueNPC, Vector2.DOWN);
//                }
//
//                break;
//              case "v":
//                if (x < 7) {
//                  addNPC(Assets.redNPC, Vector2.LEFT);
//                } else {
//                  addNPC(Assets.blueNPC, Vector2.LEFT);
//                }
//
//                break;
//              case "B":
//                addComponent(Assets.boss);
//                break;
//              case "k":
//                addComponent(Assets.key);
//                break;
//              case "l":
//                addComponent(Assets.lock);
//                break;
//              case "p":
//                if (x < 7) {
//                  addComponent(Assets.redPotion);
//                } else {
//                  addComponent(Assets.bluePotion);
//                }
//                break;
//              case "s":
//                addComponent(Assets.slime);
//                break;
              case "0":
                if (x < 7) {
                  addComponent(Assets.redButton1);
                } else {
                  addComponent(Assets.redWall1);
                }

                break;
              case "1":
                if (x < 7) {
                  addComponent(Assets.blueWall1);
                } else {
                  addComponent(Assets.blueButton1);
                }

                break;
              case "2":
                if (x < 7) {
                  addComponent(Assets.redButton2);
                } else {
                  addComponent(Assets.redWall2);
                }

                break;
              case "3":
                if (x < 7) {
                  addComponent(Assets.blueWall2);
                } else {
                  addComponent(Assets.blueButton2);
                }

                break;
              case "5":
                if (x < 7) {
                  addComponent(Assets.blueWall3);
                } else {
                  addComponent(Assets.blueButton3);
                }

                break;
            }

            x++;
          }

          y++;
        }

        y = 0;

        for (String line in map.split("\n")) {
          x = 0;

          for (int c in line.codeUnits) {
            switch (new String.fromCharCode(c)) {
              case "G":
                addCharacter(Assets.warrior);
                break;
              case "M":
                addCharacter(Assets.mage);
                break;
            }

            x++;
          }

          y++;
        }
//       });
  }
}