part of dungeon;

class Vector2 {
  static final ZERO = const Vector2(0.0, 0.0);
  static final ONE = const Vector2(1.0, 1.0);
  static final UP = const Vector2(0.0, -1.0);
  static final DOWN = const Vector2(0.0, 1.0);
  static final LEFT = const Vector2(-1.0, 0.0);
  static final RIGHT = const Vector2(1.0, 0.0);

  final double x;
  final double y;

  const Vector2(this.x, this.y);

  operator +(Vector2 that) => new Vector2(x + that.x, y + that.y);
  operator -(Vector2 that) => new Vector2(x - that.x, y - that.y);
  operator *(double factor) => new Vector2(x * factor, y * factor);
  operator ==(Vector2 that) => x == that.x && y == that.y;

  Vector2 get inverted => new Vector2(-x, -y);
}